function Ymap = get_INEPTmap(ex,INEPT_type)
ex.H0 = 2*pi*HZJij(ex.S,ex.ChSh,ex.J,ex.B0,"full");
[Q,E0] = eig(full(ex.H0));
r0 = DensityMatrix('100%_SingletSpinOrder',ex.S,ex.n1,ex.n2);%select spins
r0 = r0.RemoveCoherences(Q); 

%r0= DensityMatrix(ex.S.SSzznorm(ex.n1,ex.n2));
%r0 = r0.RemoveCoherences(Q);


Ymap.X=zeros(length(ex.t2v),length(ex.t1v));
Ymap.Y=zeros(length(ex.t2v),length(ex.t1v));
Ymap.Z=zeros(length(ex.t2v),length(ex.t1v));

    for it1=1:length(ex.t1v)
        it1/length(ex.t1v)*100
        t1=ex.t1v(it1);    
        for it2=1:length(ex.t2v)        
        t2=ex.t2v(it2);
        switch INEPT_type
            case "phINEPTplus"
                rM = phINEPTplus(r0,ex.H0,t1,t2,ex.S,ex.eH,    ex.eC);                
            case "o10sel90_phINEPTplus"
                rM = o10sel90_phINEPTplus(r0,ex.H0,t1,t2,ex.S,ex.eH,ex.eC);
            case "o01sel90_phINEPTplus"
                rM = o01sel90_phINEPTplus(r0,ex.H0,t1,t2,ex.S,ex.eH,ex.eC);
            case "o11sel90_phINEPTplus"
                rM = o11sel90_phINEPTplus(r0,ex.H0,t1,t2,ex.S,ex.eH,ex.eC);
            case "sel90_phINEPTplus"
                rM = sel90_phINEPTplus(r0,ex.H0,t1,t2,ex.S,ex.eH,ex.eC);
            case "osel90_phINEPTplus"
                rM = phINEPTplus(r0,ex.H0,t1,t2,ex.S,ex.eH.sel,    ex.eC);                     
            case "l10sel90_phINEPTplus"
                rM = l10sel90_phINEPTplus(r0,ex.H0,t1,t2,ex.S,ex.eH,ex.eC);  
                
            case "ESOTHERIC"
                rM = ESOTHERIC(r0,ex.H0,t1,t2,t1,ex.S,ex.eH,    ex.eC);                
            case "SPESOTHERIC"
                rM = SPESOTHERIC(r0,ex.H0,t1,t2,t1,ex.S,ex.eH,    ex.eC); 
            case "SEPP"
                rM = SEPP(r0,ex.H0,t1,ex.S,ex.eH); 
            case "SEPPINEPT+"
                t0=ex.t0;
                rM = SEPPINEPTplus(r0,ex.H0,t0,t2,t1,ex.S,ex.eH,ex.eC); 
            case "SEPPINEPT+others"
                t0=ex.t0;
                rM = SEPPINEPTplusothers(r0,ex.H0,t0,t2,t1,ex.S,ex.eH,ex.eC); 
                
            otherwise
                error
        end
        Ymap = get_Amplitudes(rM,ex.SOs,Ymap,it1,it2);
        end
    end
end

