%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all; %clear all and delete all previous data
LoadPath();
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tic 
%%%%%%%%%%%%%%%%%  phINEPT+, start from S, evolution during seq %%%%%%
%___1__ 2___3____4____5___6____7___8_____9__10
%phINEPTplus
%1H%__(45)Y-t1-(180)X-t1-(90)Y-t2-(180)X-t2
% X%_______-t1-(180)X-t1-(90)X-t2-(180)X-t2-FID
%SEPP_phINEPTplus
%1H%__(90)Ysel-t1-(180)X-t1-(90)Y-t2-(180)X-t2
% X%__________-t1-(180)X-t1-(90)X-t2-(180)X-t2-FID
%ESOTHERIC
%1H%__(90)Y-t1-(180)X-t1-(90)mY-t2-(180)X-t2-(90)Y-t1-(180)X-t1-
% X%_______-t1-(180)X-t1-______-t2-______-t2-(90)Y-t1-(180)X-t1-FID

System=load_System_name();
System_index=2;%8 10 23 24


ex = load_System(System{System_index});
ex.B0=9.4;% Tesla
ex.t1v = linspace(0.0,0.1,101)';
ex.t2v = 0;
ex.t0 = 1/(4*ex.J(1,2))

ex.H0 = 2*pi*HZJij(ex.S,ex.ChSh,ex.J,ex.B0,"full");
[Q,E0] = eig(full(ex.H0));
r0 = DensityMatrix('100%_SingletSpinOrder',ex.S,ex.n1,ex.n2);%select spins
r0 = r0.RemoveCoherences(Q); 

Ymap.X=zeros(length(ex.t1v),1);
Ymap.Y=zeros(length(ex.t1v),1);
Ymap.Z=zeros(length(ex.t1v),1);

for it1=1:length(ex.t1v)
    it1/length(ex.t1v)*100
    t1=ex.t1v(it1);    
    rM = SEPP(r0,ex.H0,t1,ex.S,ex.eH);         
    Amps = real(Amplitudes(rM,ex.SOs1H))*100; 
    Ymap.X(it1)=Amps(1);
    Ymap.Y(it1)=Amps(2);
    Ymap.Z(it1)=Amps(3);
end
figure
plot(ex.t1v,[Ymap.X,Ymap.Y,Ymap.Z]);
%plot_Ymap(ex,Ymap);

Folder="out/";
save_Ymap(Folder,"SEPP",System{System_index},ex,Ymap)

toc








