%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all; %clear all and delete all previous data
LoadPath();
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tic 
%%%%%%%%%%%%%%%%%  phINEPT+, start from S, evolution during seq %%%%%%
%___1__ 2___3____4____5___6____7___8_____9__10
%phINEPTplus
%1H%__(45)Y-t1-(180)X-t1-(90)Y-t2-(180)X-t2
% X%_______-t1-(180)X-t1-(90)X-t2-(180)X-t2-FID
%SEPP_phINEPTplus
%1H%__(90)Ysel-t1-(180)X-t1-(90)Y-t2-(180)X-t2
% X%__________-t1-(180)X-t1-(90)X-t2-(180)X-t2-FID
%ESOTHERIC
%1H%__(90)Y-t1-(180)X-t1-(90)mY-t2-(180)X-t2-(90)Y-t1-(180)X-t1-
% X%_______-t1-(180)X-t1-______-t2-______-t2-(90)Y-t1-(180)X-t1-FID

System=load_System_name();
System_index=29;%28 29

Folders{1}="outJCH1JCH2PHINEPT";
Folders{2}="outJCH1JCH2ESOTHERIC030";
Folders{3}="outJCH1JCH2SPIN011";
Folders{4}="outJCH1JCH2SEPPINEPT";
Folders{5}="outJCH1JCH2";
Folders{6}="outJCH1JCH2ESOTHERIC015";
Folders{7}="outJCH1JCH2ESOTHERIC2";
Folders{8}="outJCH1JCH2SEPPOTHERS2";

Folder=Folders{8}

INEPT_type{1}=         "phINEPTplus";
INEPT_type{2}=   "sel90_phINEPTplus";
INEPT_type{3}=  "osel90_phINEPTplus";
INEPT_type{4}="o11sel90_phINEPTplus";
INEPT_type{5}="o01sel90_phINEPTplus";
INEPT_type{6}="o10sel90_phINEPTplus";
INEPT_type{7}=           "ESOTHERIC";
INEPT_type{8}=         "SPESOTHERIC";
INEPT_type{9}=          "SEPPINEPT+";
INEPT_type{10}=   "SEPPINEPT+others";

INEPT_type_index=10;

ex = load_System(System{System_index});
ex.B0=9.4;% Tesla
ex.t0 = 1/(4*ex.J(1,2)) % set for sepp

%ex.t1v = linspace(0.0,0.3,200)';
%ex.t2v = linspace(0.0,0.3,202)';
%JCH1=linspace(-10,10,112/2)';
%JCH2=linspace(-10,10,110/2)';

% t1v = linspace(0.0,0.3,200)';
% t2v = linspace(0.0,0.3,202)';
% JCH1=linspace(-10,10,113)';
% JCH2=linspace(-10,10,111)';

ex.t1v = linspace(0.0,0.15,40*3)';
ex.t2v = linspace(0.0,0.15,41*3)';
JCH1=linspace(-10,10,40*2)';
JCH2=linspace(-10,10,41*2)';

Data5=zeros(length(JCH1)*length(JCH2),6);
DataMaxX=zeros(length(JCH2),length(JCH1));
DataMaxY=zeros(length(JCH2),length(JCH1));
DataMaxZ=zeros(length(JCH2),length(JCH1));

c=0;
for j1=1:length(JCH1)
    j1
    for j2=1:length(JCH2)
        c=c+1;
        ex.J(1,3)=JCH1(j1);
        ex.J(2,3)=JCH2(j2);        
        Ymap = get_INEPTmap(ex,INEPT_type{INEPT_type_index});
        %%'max'
        %[m, n1]=max(max(abs(real(Ymap.X)*100)));
        %[m, n2]=max(abs(Ymap.X(:,n1)));
        %display("tau 1, tau 2, maxP");
        %[ex.t1v(n1), ex.t2v(n2), Ymap.X(n2,n1)]                        
        DataMaxX(j2,j1)=max(max(abs(Ymap.X)));
        DataMaxY(j2,j1)=max(max(abs(Ymap.Y)));
        DataMaxZ(j2,j1)=max(max(abs(Ymap.Z)));

        %(j1-1)*length(JCH2)+j2
        %DataX5(c,:)=[JCH2(j2), JCH1(j1), ex.t1v(n1), ex.t2v(n2), DataMaxX(j2,j1), Ymap.Y(n2,n1)];
    end
end

save(Folder+"\DataMaxX.dat","DataMaxX","-ASCII");
save(Folder+"\DataMaxY.dat","DataMaxY","-ASCII");
save(Folder+"\DataMaxZ.dat","DataMaxZ","-ASCII");
%save(Folder+"\Data5.dat","Data5","-ASCII");
out=ex.t2v;
save(Folder+"\t2v.dat","out","-ASCII");
out=ex.t1v;
save(Folder+"\t1v.dat","out","-ASCII");
out=JCH1;
save(Folder+"\JCH1.dat","out","-ASCII");
out=JCH2;
save(Folder+"\JCH2.dat","out","-ASCII");

[X, Y] = meshgrid(JCH1,JCH2); 
texts.x = 'JCH1 (Hz)';
texts.y = 'JCH2 (Hz)';
texts.title = ' ';
ax=plot2D(X,Y,DataMaxX,texts);

[X, Y] = meshgrid(JCH1,JCH2); 
texts.x = 'JCH1 (Hz)';
texts.y = 'JCH2 (Hz)';
texts.title = ' ';
ax=plot2D(X,Y,DataMaxY,texts);

toc








